var StandardFB = {};

var StandardFBConst = {
    MAXINT16 : 32767,
    MAXINT32 : 2147483647,
    MAXLONG64 : 9223372036854775808,
    MAXULONG64 : 18446744073709551615,
    MININT16 : -32768,
    MININT32 : -2147483648,
    MINLONG64 : -9223372036854775807

};

/**
 * @return {number}
 */
function StandardFBTime()
{
    return new Date();
};
//-------------------------Триггеры--------------------------------------


StandardFB.RS = function () {
    this.Q1 = false;
    this.EnO = true;
    this.R1 = false;
    this.S = false;
};

StandardFB.RS.prototype._call = function () {
    this.Q1 = (this.Q1 || this.S) && !this.R1;
    //sr->Q1=(sr->Q1||sr->S)&&!sr->R1;
};


StandardFB.SR = function () {
    this.Q1 = false;
    this.EnO = true;
    this.R = false;
    this.S1 = false;
};

StandardFB.SR.prototype._call = function () {
    this.Q1 = (this.Q1 && !this.R) || this.S1;
    //sr->Q1=(sr->Q1&&!sr->R)||sr->S1;
};

GET_CURRENT_USERNAME = function () {
    this.EnO = true;
    this.Username = "";
    this.UserGroup = "";
    this.LoginTime = Date.now();
}

GET_CURRENT_USERNAME.prototype._call = function () {
    this.Username = getProp("username");
    this.UserGroup = getProp("groupnames");
    this.LoginTime = Date.now();
}

PlaySound = function () {
    this.EnO = true;
    this.Play = false;
    this.Priority = 1;
    this.lePlay = {value: false};
    this.Rep = false;
    this.Stop = false;
    this.leStop = { value: false };
    this.Sound = "";
};

PlaySound.prototype._call = function () {
    if (getLeadEdge(this.Play, this.lePlay) || getBackEdge(this.Play, this.lePlay)) {
        callAction({ type: "sound", params: this });
    }
    if (getLeadEdge(this.Stop, this.leStop) || getBackEdge(this.Stop, this.leStop)) {
        callAction({ type: "stop", params: this });
    }
};

//-------------------------Счетчики--------------------------------------
StandardFB.CTU = function () {
    this.Q = false;
    this.EnO = true;
    this.CV = 0;
};

StandardFB.CTU.prototype._call = function () {
    if(this.R)
        this.CV = 0;
    else if (this.CU && (this.CV <StandardFBConst.MAXINT16))
        this.CV += 1;
    this.Q = this.CV >= this.PV

};
StandardFB.CTU_DINT = function () {
    this.Q = false;
    this.EnO = true;
    this.CV = 0;
};

StandardFB.CTU_DINT.prototype._call = function () {
    if(this.R)
        this.CV = 0;
    else if (this.CU && (this.CV < StandardFBConst.MAXINT32))
        this.CV += 1;
    this.Q = this.CV >= this.PV


};

StandardFB.CTU_LINT = function () {
    this.Q = false;
    this.EnO = true;
    this.CV = 0;
};

StandardFB.CTU_LINT.prototype._call = function () {
    if(this.R)
        this.CV = 0;
    else if (this.CU && (this.CV < StandardFBConst.MAXLONG64))
        this.CV += 1;
    this.Q = this.CV >= this.PV


};

StandardFB.CTU_UDINT = function () {
    this.Q = false;
    this.EnO = true;
    this.CV = 0;
};

StandardFB.CTU_UDINT.prototype._call = function () {
    if(this.R)
        this.CV = 0;
    else if (this.CU && (this.CV < StandardFBConst.MAXINT32))
        this.CV += 1;
    this.Q = this.CV >= this.PV


};

StandardFB.CTU_ULINT = function () {
    this.Q = false;
    this.EnO = true;
    this.CV = 0;
};
StandardFB.CTU_ULINT.prototype._call = function () {
    if(this.R)
        this.CV = 0;
    else if (this.CU && (this.CV < StandardFBConst.MAXULONG64))
        this.CV += 1;
    this.Q = this.CV >= this.PV


};

////////////////////////////////////////////////////////////////////

StandardFB.CTD = function () {
    this.Q = false;
    this.EnO = true;
    this.CV = 0;
};

StandardFB.CTD.prototype._call = function () {
    if(this.LD)
        this.CV = this.PV;
    else if (this.CD && this.CV > StandardFBConst.MININT16)
        this.CV -= 1;
    this.Q = this.CV <= 0;
};

StandardFB.CTD_DINT = function () {
    this.Q = false;
    this.EnO = true;
    this.CV = 0;
};

StandardFB.CTD_DINT.prototype._call = function () {
    if(this.LD)
        this.CV = this.PV;
    else if (this.CD && this.CV > StandardFBConst.MININT32)
        this.CV -= 1;
    this.Q = this.CV <= 0;
};

StandardFB.CTD_LINT = function () {
    this.Q = false;
    this.EnO = true;
    this.CV = 0;
};

StandardFB.CTD_LINT.prototype._call = function () {
    if(this.LD)
        this.CV = this.PV;
    else if (this.CD && this.CV > StandardFBConst.MINLONG64)
        this.CV -= 1;
    this.Q = this.CV <= 0;
};

StandardFB.CTD_UDINT = function () {
    this.Q = false;
    this.EnO = true;
    this.CV = 0;
};

StandardFB.CTD_UDINT.prototype._call = function () {
    if(this.LD)
        this.CV = this.PV;
    else if (this.CD && this.CV > 0)
        this.CV -= 1;
    this.Q = this.CV <= 0;
};

////////////////////////////////////////////////////////////////////////////


StandardFB.CTUD = function () {
    this.EnO = true;
    this.CV = 0;
    this.QU = false;
    this.QD = false;
};

StandardFB.CTUD.prototype._call = function () {
    if(this.R)
        this.CV = 0;
    else if (this.LD)
        this.CV=this.PV;
    else
    if (!(this.CU && this.CD)) {
        if (this.CU && (this.CV<StandardFBConst.MAXINT16))
            this.CV += 1;
        else if (this.CD && (this.CV> StandardFBConst.MININT16))
            this.CV -= 1;
    }
    this.QU = this.CV >= this.PV;
    this.QD = this.CV <= 0;
};

StandardFB.CTUD_DINT = function () {
    this.EnO = true;
    this.CV = 0;
    this.QU = false;
    this.QD = false;
};

StandardFB.CTUD_DINT.prototype._call = function () {
    if(this.R)
        this.CV = 0;
    else if (this.LD)
        this.CV=this.PV;
    else
    if (!(this.CU && this.CD)) {
        if (this.CU && (this.CV<StandardFBConst.MAXINT32))
            this.CV += 1;
        else if (this.CD && (this.CV>StandardFBConst.MININT32))
            this.CV -= 1;
    }
    this.QU = this.CV >= this.PV;
    this.QD = this.CV <= 0;
};

StandardFB.CTUD_LINT = function () {
    this.EnO = true;
    this.CV = 0;
    this.QU = false;
    this.QD = false;
};

StandardFB.CTUD_LINT.prototype._call = function () {
    if(this.R)
        this.CV = 0;
    else if (this.LD)
        this.CV=this.PV;
    else
    if (!(this.CU && this.CD)) {
        if (this.CU && (this.CV<StandardFBConst.MAXLONG64))
            this.CV += 1;
        else if (this.CD && (this.CV>StandardFBConst.MINLONG64))
            this.CV -= 1;
    }
    this.QU = this.CV >= this.PV;
    this.QD = this.CV <= 0;
};

StandardFB.CTUD_ULINT = function () {
    this.EnO = true;
    this.CV = 0;
    this.QU = false;
    this.QD = false;


};

StandardFB.CTUD_ULINT.prototype._call = function () {
    if(this.R)
        this.CV = 0;
    else if (this.LD)
        this.CV=this.PV;
    else
    if (!(this.CU && this.CD)) {
        if (this.CU && (this.CV<StandardFBConst.MAXULONG64))
            this.CV += 1;
        else if (this.CD && (this.CV>0))
            this.CV -= 1;
    }
    this.QU = this.CV >= this.PV;
    this.QD = this.CV <= 0;
};
//////////////////////////////////////////////////////////////////////////
StandardFB.TP = function () {

    this.EnO = true;
    this.ET = 0;
    this.Q = false;
    this.En = true;
    this.IN = false;
    this.PT = 0;
    this.state = 0;
};

StandardFB.TP.prototype._call = function () {


    if (this.IN) {
        if (this.state == 0) {
            this.safePT = this.PT;
            this.state = 1;
            this.ET = 0;
            this.Q = true;
            this.startTime = StandardFBTime();
            return;
        }
        if (this.state == 1) {
            this.Q = true;
            this.ET = StandardFBTime() - this.startTime;
            if (this.ET >= this.safePT)
                this.state = 2;
            else
                return;

        }
        if (this.state == 2) {
            this.Q = false;
            this.ET = this.safePT;
            return;
        }

    }
    else
    {
        if (this.state == 1) {
            this.Q = true;
            this.ET = StandardFBTime() - this.startTime;
            if (this.ET >= this.safePT) {
                this.state = 2;
            }
            else
                return;
        }
        if (this.state == 2) {
            this.state = 0;
        }
        if (state == 0) {
            this.ET = 0;
            this.Q = false;
            return;
        }

    }
};
StandardFB.TON = function () {

    this.EnO = true;
    this.ET = 0;
    this.Q = false;
    this.En = true;
    this.IN = false;
    this.PT = 0;
    this.state = 0;
};

StandardFB.TON.prototype._call = function () {

    if (this.IN) {
        if (this.state == 0) {
            this.safePT = this.PT;
            this.startTime = StandardFBTime();
            this.Q = false;
            this.ET = 0;
            this.state = 1;
            return;
        }
        if (this.state == 1) {
            this.Q = false;
            this.ET = StandardFBTime() - this.startTime;
            if (this.ET >= this.safePT) {
                this.state = 2;
            }
            else
                return;
        }

        if (this.state == 2) {
            this.Q = true;
            this.ET = this.safePT;
            return;
        }
    }
    else
    {
        if (this.state == 1) {
            this.Q = false;
            this.ET = StandardFBTime() - this.startTime;
            if (this.ET >= this.safePT)
                this.state = 2;
            else
                this.state = 0;
            return;

        }
        if (this.state == 2) {
            this.state = 0;
        }
        if (this.state == 0) {
            this.ET = 0;
            this.Q = false;
            return;
        }
    }
};


StandardFB.TOF = function () {

    this.EnO = true;
    this.ET = 0;
    this.Q = false;
    this.En = true;
    this.IN = false;
    this.PT = 0;
};

StandardFB.TOF.prototype._call = function () {
    if (this.IN) {
        this.state = 1;
        this.Q = true;
        this.ET = 0;
        return;
    }
    else
    {
        if (this.state == 0) {
            this.ET = this.safePT;
            this.Q = false;
            return;
        }
        if (this.state == 1) {
            this.startTime = StandardFBTime();
            this.safePT = this.PT;
            this.state = 2;


            this.Q = true;
            this.ET = 0;
            return;


        }
        if (this.state == 2) {
            this.Q = true;
            this.ET = StandardFBTime() - this.startTime;
            if (this.ET > this.safePT) {
                this.state = 3;
            }
        }
        if (this.state == 3) {
            this.Q = false;
            this.ET = this.safePT;
        }
    }
};

//////////////////////////////////////////////////////////////////////


StandardFB.R_TRIG = function () {

    this.EnO = true;
    this.Q = false;
    this.En = true;
    this.CLK = false;


};

StandardFB.R_TRIG.prototype._call = function () {
    this.Q = this.CLK && !this.M;
    this.M = this.CLK;

};
StandardFB.F_TRIG = function () {

    this.EnO = true;
    this.Q = false;
    this.En = true;
    this.CLK = false;


};

StandardFB.F_TRIG.prototype._call = function () {
    this.Q = !this.CLK && !this.M;
    this.M = !this.CLK;
};

